/* define some variable that might conflict with the procedures 
   and functions and theirs' parameters*/
DEFINE VARIABLE p1 AS CHARACTER NO-UNDO.
DEFINE VARIABLE p4 AS CHARACTER.
DEFINE VARIABLE p3 AS INTEGER.
DEFINE VARIABLE f1 AS LOGICAL NO-UNDO.

/* both p1 and q1 should be de-registered */
FUNCTION f1 RETURNS CHARACTER (OUTPUT p1 AS CHARACTER, OUTPUT q1 AS CHARACTER).
   RETURN "r1".
END FUNCTION.

/* no de-registration needed */
FUNCTION f4 RETURNS CHARACTER (p4 AS INTEGER, q4 AS INTEGER).
   RETURN "r4".
END FUNCTION.

/* lots of parameters, and different passing modes */
/* only p1 and t2 should be de-registered  */
/* p1 intentionally keep the same name as the first parameter from
   previous function to further detect 'leaks' */
FUNCTION f2 RETURNS CHARACTER (OUTPUT p1 AS INTEGER,
                               INPUT  q2 AS INTEGER,
                                      r2 AS INTEGER,
                               INPUT  s2 AS INTEGER,
                               INPUT-OUTPUT t2 AS INTEGER,
                                      u2 AS INTEGER).
   RETURN "r2".
END FUNCTION.

/* both p3 and q2 should be de-registered */
/* q2 intentionally has the same name as 2nd param of previous function */
FUNCTION f3 RETURNS CHARACTER (OUTPUT p3 AS LOGICAL, INPUT-OUTPUT q2 AS LOGICAL).
   RETURN "r3".
END FUNCTION.

/* only q1 parameter should be (de-)registered */
PROCEDURE p1:
    DEFINE INPUT PARAMETER p1 AS CHARACTER.
    DEFINE OUTPUT PARAMETER q1 AS CHARACTER.

    q1 = p1.
END PROCEDURE.

/* none of the parameters should be (de-)registered */
PROCEDURE p2:
    DEFINE INPUT PARAMETER p2 AS CHARACTER.
    DEFINE INPUT PARAMETER q2 AS CHARACTER.

    DEFINE VAR p1 AS CHARACTER.
    p1 = p2 + q2.
END PROCEDURE.

/* only p3 parameter should be (de-)registered */
PROCEDURE p3:
    DEFINE OUTPUT PARAMETER p3 AS CHARACTER.
    DEFINE INPUT PARAMETER q3 AS CHARACTER.

    p3 = q3.
END PROCEDURE.

/* call some of above functions and procedures using defined variables: */
p3 = 1.
p1 = f1("p1", "q1").
p4 = f4(p3, 0).

RUN p1 (INPUT "P1", OUTPUT p1).
RUN p2 (OUTPUT p1, INPUT "P3").

MESSAGE "All OK...".